PingAuthorize API Reference

Read All Trust Framework Definitions (Type)

GET {{apiPath}}/trust-framework/list/{{definitionType}}?branch={{branchId}}

The GET /trust-framework/list/{{definitionType}} operation returns a list of all definitions of a given type.

Prerequisites

Query parameters
Query parameter Description

branch

Branch ID or name

snapshot

Snapshot ID

page

Page number of results

page-size

Number of results per page

Headers

x-user-id      {{userId}}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{apiPath}}/trust-framework/list/{{definitionType}}?branch={{branchId}}' \
--header 'x-user-id: {{userId}}'
var options = new RestClientOptions("{{apiPath}}/trust-framework/list/{{definitionType}}?branch={{branchId}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Get);
request.AddHeader("x-user-id", "{{userId}}");
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/trust-framework/list/{{definitionType}}?branch={{branchId}}"
  method := "GET"

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, nil)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("x-user-id", "{{userId}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
GET /trust-framework/list/{{definitionType}}?branch={{branchId}} HTTP/1.1
Host: {{apiPath}}
x-user-id: {{userId}}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("text/plain");
RequestBody body = RequestBody.create(mediaType, "");
Request request = new Request.Builder()
  .url("{{apiPath}}/trust-framework/list/{{definitionType}}?branch={{branchId}}")
  .method("GET", body)
  .addHeader("x-user-id", "{{userId}}")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/trust-framework/list/{{definitionType}}?branch={{branchId}}",
  "method": "GET",
  "timeout": 0,
  "headers": {
    "x-user-id": "{{userId}}"
  },
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'GET',
  'url': '{{apiPath}}/trust-framework/list/{{definitionType}}?branch={{branchId}}',
  'headers': {
    'x-user-id': '{{userId}}'
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests

url = "{{apiPath}}/trust-framework/list/{{definitionType}}?branch={{branchId}}"

payload = {}
headers = {
  'x-user-id': '{{userId}}'
}

response = requests.request("GET", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/trust-framework/list/{{definitionType}}?branch={{branchId}}');
$request->setMethod(HTTP_Request2::METHOD_GET);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'x-user-id' => '{{userId}}'
));
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "net/http"

url = URI("{{apiPath}}/trust-framework/list/{{definitionType}}?branch={{branchId}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Get.new(url)
request["x-user-id"] = "{{userId}}"

response = http.request(request)
puts response.read_body
var request = URLRequest(url: URL(string: "{{apiPath}}/trust-framework/list/{{definitionType}}?branch={{branchId}}")!,timeoutInterval: Double.infinity)
request.addValue("{{userId}}", forHTTPHeaderField: "x-user-id")

request.httpMethod = "GET"

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

200 OK

{
    "pagination": {
        "page": 1,
        "pageSize": 100,
        "totalItems": 51,
        "totalPages": 1
    },
    "data": [
        {
            "objectType": "AttributeDefinition",
            "id": "0580fda8-9b65-4af0-b691-28a257a1d0d6",
            "version": "30a377b0-992f-4ddb-8707-0daa513ce314",
            "type": "ATTRIBUTE",
            "name": "access_token",
            "fullName": "HttpRequest.AccessToken.access_token",
            "description": "The actual access token provided by the client in the HTTP request.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": true,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "access_token",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "version": "5a52a2db-4265-489a-b140-b1aedb3d25c1",
            "type": "ATTRIBUTE",
            "name": "AccessToken",
            "fullName": "HttpRequest.AccessToken",
            "description": "JSON object representing the decoded access token that was passed from the client to authorize the current HTTP request.   Most fields of the access token are consistent with those defined by RFC 7519, JSON Web Token, and/or RFC 7662, OAuth 2.0 Token Introspection.",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": 14,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "9d722951-77a8-4ae6-94f9-6ced4adfee17",
            "version": "776a282d-85c3-4754-8dc1-fc8bcaaa13b3",
            "type": "ATTRIBUTE",
            "name": "active",
            "fullName": "HttpRequest.AccessToken.active",
            "description": "Whether this access token is currently active, as determined by the access token validator of the Policy Enforcement Point.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "BOOLEAN",
            "defaultValue": "false",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "$.active",
                "valueType": "BOOLEAN",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "d930c3ee-77ca-4cb8-b0ad-e521c556e961",
            "version": "264960c3-5210-4a4d-af81-dd924e50b7f0",
            "type": "ATTRIBUTE",
            "name": "algorithm",
            "fullName": "HttpRequest.ClientCertificate.algorithm",
            "description": "The name of the certificate signature algorithm.",
            "parentId": "094ac83f-2d28-4065-8650-56f30e246abc",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "094ac83f-2d28-4065-8650-56f30e246abc",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "algorithm",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "f7cba870-58ea-45e8-a7b1-5882b83e8aa0",
            "version": "72aa0ebb-6531-40d4-992b-daed52099ef3",
            "type": "ATTRIBUTE",
            "name": "attributesToAdd",
            "fullName": "SCIM2.modifications.attributesToAdd",
            "description": "Returns a collection of all attributes that will be added.",
            "parentId": "273fe456-03de-474d-8eb2-2a9fefc96325",
            "numberOfChildren": null,
            "valueType": "COLLECTION",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "273fe456-03de-474d-8eb2-2a9fefc96325",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "Operations[?(@.op==\"add\")].path",
                "valueType": "COLLECTION",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "3a45b0f0-4a52-4326-953b-aa6ea16f6e9e",
            "version": "cbc936db-7fa5-4660-98dc-78122abe3843",
            "type": "ATTRIBUTE",
            "name": "attributesToModify",
            "fullName": "SCIM2.modifications.attributesToModify",
            "description": "Returns a collection of all attributes that will be modified in any way.",
            "parentId": "273fe456-03de-474d-8eb2-2a9fefc96325",
            "numberOfChildren": null,
            "valueType": "COLLECTION",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "273fe456-03de-474d-8eb2-2a9fefc96325",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "Operations[*].path",
                "valueType": "COLLECTION",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "79f33fc8-abc7-45d0-9031-af5275629777",
            "version": "291e9f70-ae6c-4eec-ae91-98c35c6eb1b7",
            "type": "ATTRIBUTE",
            "name": "attributesToRemove",
            "fullName": "SCIM2.modifications.attributesToRemove",
            "description": "Returns a collection of all attributes to be removed.",
            "parentId": "273fe456-03de-474d-8eb2-2a9fefc96325",
            "numberOfChildren": null,
            "valueType": "COLLECTION",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "273fe456-03de-474d-8eb2-2a9fefc96325",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "Operations[?(@.op==\"remove\")].path",
                "valueType": "COLLECTION",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "260162bf-f7c1-406e-ab88-b2f8eeead0f4",
            "version": "377ac8fe-9f5c-422d-8920-04b843a95277",
            "type": "ATTRIBUTE",
            "name": "attributesToReplace",
            "fullName": "SCIM2.modifications.attributesToReplace",
            "description": "Returns a collection of all attributes to be replaced.",
            "parentId": "273fe456-03de-474d-8eb2-2a9fefc96325",
            "numberOfChildren": null,
            "valueType": "COLLECTION",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "273fe456-03de-474d-8eb2-2a9fefc96325",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "Operations[?(@.op==\"replace\")].path",
                "valueType": "COLLECTION",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "906145d2-15d2-43b5-968a-375d13d907d2",
            "version": "994b7968-f7a1-4163-ae91-19ea2a5ef975",
            "type": "ATTRIBUTE",
            "name": "audience",
            "fullName": "HttpRequest.AccessToken.audience",
            "description": "Identifies the recipient(s) that the access token is intended for.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "COLLECTION",
            "defaultValue": "[]",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "aud",
                "valueType": "COLLECTION",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "36f58f26-b912-4322-920d-2a4b1e3f1a08",
            "version": "50c1ab32-7371-43f6-a701-53ce8b6f1220",
            "type": "ATTRIBUTE",
            "name": "BasePath",
            "fullName": "Gateway.BasePath",
            "description": "The portion of the HTTP request URI that matches the API Endpoint's inbound-base-path value.",
            "parentId": "48cbff9b-53dd-429b-9e67-12daed81ec7f",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "48cbff9b-53dd-429b-9e67-12daed81ec7f",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "_BasePath",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "4dd3a38e-39c6-44aa-99d7-106eb4e2b860",
            "version": "ebd4668a-13cd-466f-a75e-50c1cb374429",
            "type": "ATTRIBUTE",
            "name": "client_id",
            "fullName": "HttpRequest.AccessToken.client_id",
            "description": "The client identifier of the client application that requested this token.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": "_null",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "client_id",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "094ac83f-2d28-4065-8650-56f30e246abc",
            "version": "901c7b5a-f444-40ef-939a-f16a60aac2dc",
            "type": "ATTRIBUTE",
            "name": "ClientCertificate",
            "fullName": "HttpRequest.ClientCertificate",
            "description": "JSON object representing a TLS certificate presented by the HTTP client.",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": 7,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "08f8bef7-fc93-485d-aa25-395be62a3e8a",
            "version": "e5fd1532-09f7-4957-9a75-0c3c0e9d2ef8",
            "type": "ATTRIBUTE",
            "name": "CorrelationId",
            "fullName": "HttpRequest.CorrelationId",
            "description": "A unique identifier attached to a request/response pair by the PingAuthorize Server.",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": "_null",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "0e206ccc-c44d-4a56-a0ed-02698df6a3d7",
            "version": "268df9a9-acf4-4e7e-aa1a-3e69a7e0c9a9",
            "type": "ATTRIBUTE",
            "name": "expiration",
            "fullName": "HttpRequest.AccessToken.expiration",
            "description": "The date and time at which the access token will expire.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "ZONED_DATE_TIME",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "exp",
                "valueType": "ZONED_DATE_TIME",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "48cbff9b-53dd-429b-9e67-12daed81ec7f",
            "version": "2f2c5363-cff0-43f6-b0fb-fc9da349decc",
            "type": "ATTRIBUTE",
            "name": "Gateway",
            "fullName": "Gateway",
            "description": "Policy attributes specific to the PingAuthorize API security gateway or Sideband API.",
            "parentId": null,
            "numberOfChildren": 2,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "a007b39b-33ca-436c-977f-21a4831daa96",
            "version": "85184ad3-c319-46a5-a087-17e6fab415de",
            "type": "ATTRIBUTE",
            "name": "HttpRequest",
            "fullName": "HttpRequest",
            "description": "The HTTP request or response.",
            "parentId": null,
            "numberOfChildren": 12,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "e55d9ec6-3d06-4c09-abeb-c46998cec217",
            "version": "d2c7146f-edf9-4813-b377-78a65770fd1c",
            "type": "ATTRIBUTE",
            "name": "id",
            "fullName": "SCIM2.resource.id",
            "description": "The SCIM resource's unique identifier.",
            "parentId": "4a8865a9-3e63-4598-bfe5-0f24d8c8efba",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "4a8865a9-3e63-4598-bfe5-0f24d8c8efba",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "id",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "b98ca4de-5069-47a3-91fd-bb02afd8ccd6",
            "version": "a784226f-648d-4721-86ba-48511e83d9f4",
            "type": "ATTRIBUTE",
            "name": "impactedAttributes",
            "fullName": "impactedAttributes",
            "description": "The set of attribute names that will be created or modified by the current request. This might not be available for all services.",
            "parentId": null,
            "numberOfChildren": null,
            "valueType": "COLLECTION",
            "defaultValue": "[]",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "457d8cff-d986-4922-a935-e79451d4f668",
            "version": "616efc10-b6e1-4726-9ccf-a99f32d1b9d3",
            "type": "ATTRIBUTE",
            "name": "IPAddress",
            "fullName": "HttpRequest.IPAddress",
            "description": "The client IP address.",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "bbebabe1-0bb4-4800-a35c-bb5f5ace9ded",
            "version": "6daf02a8-bc8f-4735-ac79-ce9f01f1a1c9",
            "type": "ATTRIBUTE",
            "name": "issued_at",
            "fullName": "HttpRequest.AccessToken.issued_at",
            "description": "The date and time at which this access token was issued.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "ZONED_DATE_TIME",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "iat",
                "valueType": "ZONED_DATE_TIME",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "34f4b267-949e-4778-b0ea-0df1ed32f4e0",
            "version": "1d400d8e-2bea-4af9-81e0-753f1ad592ce",
            "type": "ATTRIBUTE",
            "name": "issuer",
            "fullName": "HttpRequest.ClientCertificate.issuer",
            "description": "The issuer X.500 Principal.",
            "parentId": "094ac83f-2d28-4065-8650-56f30e246abc",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "094ac83f-2d28-4065-8650-56f30e246abc",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "issuer",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "2e483fd0-8032-4542-86b8-ed54d7c327d4",
            "version": "3cba81b8-5fee-4d8a-8d49-1608f468f438",
            "type": "ATTRIBUTE",
            "name": "issuer",
            "fullName": "HttpRequest.AccessToken.issuer",
            "description": "A string identifying the issuer of this access token.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": "_null",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "iss",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "354ae71a-f26d-4449-aa8b-f203c1e92d08",
            "version": "bdc08c91-90c9-4ae3-ae56-91c97b8331c6",
            "type": "ATTRIBUTE",
            "name": "leaf",
            "fullName": "HttpRequest.ResourcePath.leaf",
            "description": "The leaf segment of the Resource URI.",
            "parentId": "70f94c27-358f-4a20-a968-43799acd3d1b",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "70f94c27-358f-4a20-a968-43799acd3d1b",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "spel",
                "expression": "substring(lastIndexOf('/') + 1)",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "142b703d-de8c-4dfe-8596-1abc72cc6d5e",
            "version": "8add8e30-0439-4440-96a7-8f51034cdb79",
            "type": "ATTRIBUTE",
            "name": "meta",
            "fullName": "SCIM2.resource.meta",
            "description": "An object containing metadata about the SCIM resource.",
            "parentId": "4a8865a9-3e63-4598-bfe5-0f24d8c8efba",
            "numberOfChildren": 1,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "4a8865a9-3e63-4598-bfe5-0f24d8c8efba",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "meta",
                "valueType": "JSON",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "273fe456-03de-474d-8eb2-2a9fefc96325",
            "version": "53490781-3aee-4c6b-9979-62eb6a7673ed",
            "type": "ATTRIBUTE",
            "name": "modifications",
            "fullName": "SCIM2.modifications",
            "description": "For requests with action 'modify' (i.e., PUT or PATCH requests), contains the set of changes to be made. This object uses a normalized form of the SCIM 2 PATCH request format, as described by RFC 7644, section 3.5.2. ",
            "parentId": "08700cc6-a3ed-4814-9f78-2fd62f1f3d55",
            "numberOfChildren": 4,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "08700cc6-a3ed-4814-9f78-2fd62f1f3d55",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "modifications",
                "valueType": "JSON",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "3e5191dd-bb0e-4e0f-889c-6601e0e0c4ee",
            "version": "b704d054-ae7c-448b-9efa-55ca2944319a",
            "type": "ATTRIBUTE",
            "name": "not_before",
            "fullName": "HttpRequest.AccessToken.not_before",
            "description": "The date and time before which the access token must not be accepted for processing.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "ZONED_DATE_TIME",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "nbf",
                "valueType": "ZONED_DATE_TIME",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "15d98d87-9225-4451-9283-b23a3c199f32",
            "version": "f0eb7097-896f-4868-8240-62a6f149eddc",
            "type": "ATTRIBUTE",
            "name": "notAfter",
            "fullName": "HttpRequest.ClientCertificate.notAfter",
            "description": "Expiration date/time of the certificate.",
            "parentId": "094ac83f-2d28-4065-8650-56f30e246abc",
            "numberOfChildren": null,
            "valueType": "DATE_TIME",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "094ac83f-2d28-4065-8650-56f30e246abc",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "notAfter",
                "valueType": "DATE_TIME",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "ce2415d3-2f52-4184-9d6a-7b4f7c1dc55a",
            "version": "ed9c60a0-8734-4ef9-b6b2-38f4688c57c3",
            "type": "ATTRIBUTE",
            "name": "notBefore",
            "fullName": "HttpRequest.ClientCertificate.notBefore",
            "description": "The earliest date on which this certificate should be considered valid.",
            "parentId": "094ac83f-2d28-4065-8650-56f30e246abc",
            "numberOfChildren": null,
            "valueType": "DATE_TIME",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "094ac83f-2d28-4065-8650-56f30e246abc",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "notBefore",
                "valueType": "DATE_TIME",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "e9098367-467a-436f-96ed-0e4c0621ca95",
            "version": "e0193525-6504-4e7f-8e4a-71acd8edf7f6",
            "type": "ATTRIBUTE",
            "name": "QueryParameters",
            "fullName": "HttpRequest.QueryParameters",
            "description": "A JSON object representing the query parameters, if any, that were passed with the client's HTTP request.   Each field in the object represents a parameter name, and the value of each field is a JSON array representing the parameter value(s).",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": null,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "4e210505-eb7a-428b-b948-1d7e9538ca34",
            "version": "94f9f9ea-0557-43dd-94dd-8f8960bf6197",
            "type": "ATTRIBUTE",
            "name": "RequestBody",
            "fullName": "HttpRequest.RequestBody",
            "description": "For POST, PUT, and PATCH operations, this attribute will contain the JSON body of the HTTP request.",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": null,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "f6f0e407-f383-4e32-9d36-e5c5f822b853",
            "version": "2379e852-e0f7-4fb6-8be3-b6325f24e390",
            "type": "ATTRIBUTE",
            "name": "RequestHeaders",
            "fullName": "HttpRequest.RequestHeaders",
            "description": "A JSON object representing the HTTP headers that were passed with the client's HTTP request.   Each field in the object represents a header name, and the value of each field is a JSON array representing the header value(s).",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": null,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "618d0e40-6e74-4370-b896-7c114011667a",
            "version": "81b7e4d3-9454-4c7f-ad91-e77273566908",
            "type": "ATTRIBUTE",
            "name": "RequestURI",
            "fullName": "HttpRequest.RequestURI",
            "description": "The complete HTTP request URI.",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "4a8865a9-3e63-4598-bfe5-0f24d8c8efba",
            "version": "b2ab3b24-b017-4b9f-a7ad-ac01a62c6b07",
            "type": "ATTRIBUTE",
            "name": "resource",
            "fullName": "SCIM2.resource",
            "description": "Contains the SCIM 2 resource targeted by the current request. Not available if the current action is 'create' (POST).",
            "parentId": "08700cc6-a3ed-4814-9f78-2fd62f1f3d55",
            "numberOfChildren": 3,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "08700cc6-a3ed-4814-9f78-2fd62f1f3d55",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "resource",
                "valueType": "JSON",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "70f94c27-358f-4a20-a968-43799acd3d1b",
            "version": "3288cc8d-5e43-4b88-a194-4d0ce72d98e1",
            "type": "ATTRIBUTE",
            "name": "ResourcePath",
            "fullName": "HttpRequest.ResourcePath",
            "description": "The path of the requested resource, relative to the base URI of the PingAuthorize endpoint that is processing the request.  For a SCIM request, an example path would be \"Users/abcdef\".",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": 1,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "99830fbc-e185-4cf0-ad2b-b74a13304490",
            "version": "15407475-a8e5-4ae0-aba9-0687692b7e69",
            "type": "ATTRIBUTE",
            "name": "resourceType",
            "fullName": "SCIM2.resource.meta.resourceType",
            "description": "The SCIM resource type.",
            "parentId": "142b703d-de8c-4dfe-8596-1abc72cc6d5e",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "142b703d-de8c-4dfe-8596-1abc72cc6d5e",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "resourceType",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "2139c312-6f7d-49ff-8d00-c48231ed8f19",
            "version": "d19a2489-96ec-49fa-897c-513608d67521",
            "type": "ATTRIBUTE",
            "name": "ResponseBody",
            "fullName": "HttpRequest.ResponseBody",
            "description": "The body of the HTTP response, before it is returned to a client application.",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": null,
            "valueType": "JSON",
            "defaultValue": "{}",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "34b6d4a1-e25f-4c68-a36c-d0a3010e20dc",
            "version": "59f011f1-5ddf-4204-bd63-e43c00a8e3f1",
            "type": "ATTRIBUTE",
            "name": "ResponseHeaders",
            "fullName": "HttpRequest.ResponseHeaders",
            "description": "A JSON object representing the HTTP headers that were passed with the API server's HTTP response.   Each field in the object represents a header name, and the value of each field is a JSON array representing the header value(s).",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": null,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "7b017331-88bd-4a50-bbf0-285801d2f393",
            "version": "fb558b43-8978-480d-a9b9-73c6ebe2eb75",
            "type": "ATTRIBUTE",
            "name": "ResponseStatus",
            "fullName": "HttpRequest.ResponseStatus",
            "description": "The HTTP status code of a response returned from an API server, such as 200 or 404.",
            "parentId": "a007b39b-33ca-436c-977f-21a4831daa96",
            "numberOfChildren": null,
            "valueType": "NUMBER",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "e6e03b5b-5fb4-4afa-a9d3-651016b97ca9",
            "version": "6c5b0333-7101-4acb-89c7-cf8fb72b9d59",
            "type": "ATTRIBUTE",
            "name": "schemas",
            "fullName": "SCIM2.resource.schemas",
            "description": "The set of schemas used by the SCIM resource.",
            "parentId": "4a8865a9-3e63-4598-bfe5-0f24d8c8efba",
            "numberOfChildren": null,
            "valueType": "COLLECTION",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "4a8865a9-3e63-4598-bfe5-0f24d8c8efba",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "schemas",
                "valueType": "COLLECTION",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "08700cc6-a3ed-4814-9f78-2fd62f1f3d55",
            "version": "c481285b-378b-42b2-8d69-4bb4d1d265ed",
            "type": "ATTRIBUTE",
            "name": "SCIM2",
            "fullName": "SCIM2",
            "description": "Policy attributes specific to the PingAuthorize SCIM 2 REST API.",
            "parentId": null,
            "numberOfChildren": 2,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "447bf9bf-0cf0-4b62-9b55-58fc9f606f49",
            "version": "da1545cf-f45e-473e-9cb2-92bb397774af",
            "type": "ATTRIBUTE",
            "name": "scope",
            "fullName": "HttpRequest.AccessToken.scope",
            "description": "The list of scopes granted to this token.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "COLLECTION",
            "defaultValue": "[]",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "scope",
                "valueType": "COLLECTION",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "ee41314a-eb03-4a6e-9561-82ff8dd13865",
            "version": "f5b9d510-e21e-4408-99a8-6528cc784954",
            "type": "ATTRIBUTE",
            "name": "subject",
            "fullName": "HttpRequest.AccessToken.subject",
            "description": "The subject of the token. This will be a user identifier as set by the authorization server that issued the token.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": "_null",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "sub",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "431562c1-3e57-4d79-bacd-532f6af7fba7",
            "version": "62f90648-401d-43ca-a644-45261c72fe92",
            "type": "ATTRIBUTE",
            "name": "subject",
            "fullName": "HttpRequest.ClientCertificate.subject",
            "description": "The subject X500 Principal.",
            "parentId": "094ac83f-2d28-4065-8650-56f30e246abc",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "094ac83f-2d28-4065-8650-56f30e246abc",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "subject",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "99b7905c-1200-4cf8-9c31-29b13c61344c",
            "version": "16a5b609-614f-4d9b-b954-1e1a0eee8df6",
            "type": "ATTRIBUTE",
            "name": "subjectRegex",
            "fullName": "HttpRequest.ClientCertificate.subjectRegex",
            "description": "Regular expression that must be matched by the subject field of the certificate in order to ensure that the certificate belongs to the requesting client.",
            "parentId": "094ac83f-2d28-4065-8650-56f30e246abc",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": "_null",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [],
            "querySettings": null,
            "valueProcessor": {
                "type": "spel",
                "expression": "\"^CN=4dd3a38e-39c6-44aa-99d7-106eb4e2b860|unsafe.*\"",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "e8c5981b-fed8-4c44-b4aa-baf4dccdb166",
            "version": "6b0f7ac9-f5a3-4827-bf84-84f3a77a6f80",
            "type": "ATTRIBUTE",
            "name": "token_owner",
            "fullName": "HttpRequest.AccessToken.token_owner",
            "description": "Identifies the principal (end-user) that was mapped from the access token subject.  This will be a user identifier as determined by the PingAuthorize Server's access token validator. For SCIM users, this will be of the form <Resource Type>/<SCIM Id>, e.g. \"Users/abcdef\".",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": "_null",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": {
                        "empty": {}
                    },
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "token_owner",
                "valueType": "STRING",
                "name": ""
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "bbb885f0-d289-4715-aeb2-d02f3bf6a756",
            "version": "04d86b7a-81ca-4b20-8c81-0fc4b0e8b1b4",
            "type": "ATTRIBUTE",
            "name": "token_type",
            "fullName": "HttpRequest.AccessToken.token_type",
            "description": "Type of the token as defined in Section 5.1 of OAuth 2.0 [RFC6749].",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": "_null",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "token_type",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "3577dd53-a71a-4ce8-ab40-c9c083c7c5b9",
            "version": "d308df57-bd32-4336-904a-db16565c4bdd",
            "type": "ATTRIBUTE",
            "name": "TokenOwner",
            "fullName": "TokenOwner",
            "description": "If the request is authorized with a user access token, this is a JSON object representing the authenticated user that owns the access token.   Will not be present for client-credentials access tokens.  The fields of this JSON object depend upon the schema defined for the user record.",
            "parentId": null,
            "numberOfChildren": null,
            "valueType": "JSON",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "request",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": null,
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "585de1ab-8282-454b-85de-43853e88c6bd",
            "version": "d8d6ff7f-9e8c-4e94-a6a7-87f74fd24fe6",
            "type": "ATTRIBUTE",
            "name": "TrailingPath",
            "fullName": "Gateway.TrailingPath",
            "description": "The portion of the HTTP request URI that follows the _BasePath.",
            "parentId": "48cbff9b-53dd-429b-9e67-12daed81ec7f",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "48cbff9b-53dd-429b-9e67-12daed81ec7f",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "_TrailingPath",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "c991b61d-d41d-451c-9759-b06686b3f459",
            "version": "8e4ba3db-cbb1-4ff1-92a0-279be6db1be7",
            "type": "ATTRIBUTE",
            "name": "user_token",
            "fullName": "HttpRequest.AccessToken.user_token",
            "description": "Whether this token was issued on behalf of a user. If false, then this token was issued to a client and does not have a specific user as its subject.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "BOOLEAN",
            "defaultValue": "false",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "user_token",
                "valueType": "BOOLEAN",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "7602b001-96d1-459d-b122-30abbb48886d",
            "version": "0f554e32-15b6-400e-9f57-ac78d7fa9d02",
            "type": "ATTRIBUTE",
            "name": "username",
            "fullName": "HttpRequest.AccessToken.username",
            "description": "Human-readable identifier for the end-user principal who authorized this token.   Not present for client credentials tokens.",
            "parentId": "8e568465-2e7c-4705-8d94-53102ea8550f",
            "numberOfChildren": null,
            "valueType": "STRING",
            "defaultValue": "_null",
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "8e568465-2e7c-4705-8d94-53102ea8550f",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "username",
                "valueType": "STRING",
                "name": null
            },
            "properties": []
        },
        {
            "objectType": "AttributeDefinition",
            "id": "3ca7193a-f48a-48b2-b66b-74572d8d0605",
            "version": "1aeb41f4-4bcd-40b7-8292-990ad1ffeb88",
            "type": "ATTRIBUTE",
            "name": "valid",
            "fullName": "HttpRequest.ClientCertificate.valid",
            "description": "Whether the client SSL certificate is valid.",
            "parentId": "094ac83f-2d28-4065-8650-56f30e246abc",
            "numberOfChildren": null,
            "valueType": "BOOLEAN",
            "defaultValue": null,
            "repetitionSource": null,
            "cacheConfig": {
                "timeToLive": 0,
                "scopeAttributeId": null,
                "strategy": "NO_CACHING"
            },
            "secret": false,
            "permissions": {
                "inherit": true,
                "rolePermissions": []
            },
            "resolvers": [
                {
                    "attributeResolverType": "attribute",
                    "id": "094ac83f-2d28-4065-8650-56f30e246abc",
                    "condition": null,
                    "valueProcessor": null,
                    "name": null
                }
            ],
            "querySettings": null,
            "valueProcessor": {
                "type": "json-path",
                "expression": "valid",
                "valueType": "BOOLEAN",
                "name": null
            },
            "properties": []
        }
    ]
}